' declare library constants.
Const MAX_PATH = 260
Const INVALID_HANDLE_VALUE = -1
Const ERROR_FILE_NOT_FOUND = 2
Const ERROR_NO_MORE_FILES = &H12
Const ByteDivisor = 1024
Const ByteDivisor2 = 1024

Declare Dynamic Library "Shell32"
   Function IsUserAnAdmin& ()
   Sub ShellExecute Alias "ShellExecuteA" (ByVal hwnd As _Offset, lpOperation As String, lpFile As String, lpParameters As String, ByVal lpDirectory As _Offset, ByVal nShowCmd As Long)
End Declare

' declare library structures.
Type FILETIME
   dwLowDateTime As _Unsigned Long
   dwHighDateTime As _Unsigned Long
End Type

Type SYSTEMTIME
   wYear As Integer
   wMonth As Integer
   wDayOfWeek As Integer
   wDay As Integer
   wHour As Integer
   wMinute As Integer
   wSecond As Integer
   wMilliseconds As Integer
End Type

Type WIN32_FIND_DATAA
   dwFileAttributes As _Unsigned Long
   ftCreationTime As FILETIME
   ftLastAccessTime As FILETIME
   ftLastWriteTime As FILETIME
   nFileSizeHigh As _Unsigned Long
   nFileSizeLow As _Unsigned Long
   dwReserved0 As _Unsigned Long
   dwReserved1 As _Unsigned Long
   cFileName As String * Max_path
   cAlternateFileName As String * 14
End Type

' declare external library
Declare Library "mem"
   Function MemInUsePercent~&&
   Function TotalPhysicalMem~&&
   Function FreePhysicalMem~&&
   Function TotalPagingFile~&&
   Function FreePagingFile~&&
   Function TotalVirtualMem~&&
   Function FreeVirtualMem~&&
   Function FreeExtendedMem~&&
   Function GetCPULoad#
End Declare

' declare external libraries.
Declare Dynamic Library "kernel32"
   Function GetLocalTime& (lpSystemTime As SYSTEMTIME)
   Function SetLocalTime& (lpSystemTime As SYSTEMTIME)
   Function GetSystemTime& (lpSystemTime As SYSTEMTIME)
   Function SetSystemTime& (lpSystemTime As SYSTEMTIME)

   Function FindFirstFileA~%& (ByVal lpFileName~%&, ByVal lpFindFileData~%&)
   Function FindNextFileA& (ByVal hFindFile~%&, ByVal lpFindFileData~%&)
   Function FindFirstFileW~%& (ByVal lpFileName~%&, ByVal lpFindFileData~%&)
   Function FindNextFileW& (ByVal hFindFile~%&, ByVal lpFindFileData~%&)
   Function FindClose& (ByVal hFindFile~%&)

   Function GetVolumeInformationA& (lpRootPathName$, lpVolumeNameBuffer$, ByVal nVolumeNameSize~&, lpVolumeSerialNumber~&, lpMaximumComponentLength~&, lpFileSystemFlags~&, lpFileSystemNameBuffer$, ByVal nFileSystemNameSize&)
   Function GetDiskFreeSpaceA& (f$, sectors&, bytes&, free&, total&)
   Function GetDiskFreeSpaceExA& (filename$, free As _Unsigned _Integer64, total As _Unsigned _Integer64, free2 As _Unsigned _Integer64)
   Function SetVolumeLabelA% (d$, f$)

   Function GetFileTime& (ByVal hFile As _Offset, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME)
   Function SetFileTime& (ByVal hFile As _Offset, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME)
   Function FileTimeToSystemTime& (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME)
   Function SystemTimeToFileTime& (lpSystemTime As SYSTEMTIME, lpFileTime As FILETIME)

   Function DeleteFileA% (F$)
   Function RemoveDirectoryA% (F$)
   Function CreateDirectoryA% (F$, ByVal X&&)
   Function SetCurrentDirectoryA% (f$)
   Function CloseHandle& (ByVal hfile As _Offset)
   Function GetLastError& ()
   Function FormatMessageA& (ByVal f As Long, f$, ByVal e As Long, ByVal d As Long, g$, ByVal s As Long, h$)

   Function MultiByteToWideChar& (ByVal codePage~&, ByVal dwFlags~&, lpszMbstring$, ByVal byteCount&, lpwszWcstring$, ByVal wideCount&)
   Function WideCharToMultiByte& (ByVal codePage~&, ByVal dwFlags~&, lpWideString$, ByVal ccWideChar%, lpMultiByte$, ByVal multibyte%, ByVal defaultchar&, ByVal usedchar&)
   Function MoveFileW (f$, g$)
End Declare

Declare Library
   Function GetFileAttributes& (f$)
   Function SetFileAttributes& (f$, ByVal a&)
   Function GetDriveType& (d$)
   Function GetShortPathName& (InP$, OutP$, ByVal length&)
   Function GetModuleFileNameA (ByVal Module As Long, FileName As String, ByVal nSize As Long)
   Function MoveFile (f$, g$)
   Function CopyFile (f$, g$, ByVal f%)

   Function EncryptFile (f$)
   Function DecryptFile (f$, ByVal f&)
   Function EncryptFileA (f$)
   Function DecryptFileA (f$, ByVal f&)
End Declare

Declare Dynamic Library "advapi32"
   Function FileEncryptionStatusA% (f$, f&)
End Declare

Declare Dynamic Library "user32"
   Function GetDesktopWindow%& ()
   Function SendMessageA%& (ByVal hWnd%&, ByVal Msg~&, ByVal wParam~%&, ByVal lParam%&)
End Declare

$VersionInfo:CompanyName='eoredson'
$VersionInfo:FileDescription='The Hex Editor'
$VersionInfo:InternalName='sic64.bas'
$VersionInfo:LegalCopyright='PD'
$VersionInfo:LegalTrademarks='PD'
$VersionInfo:OriginalFilename='sic64.exe'
$VersionInfo:ProductName='SICK'
$VersionInfo:Comments='SICK The Symbolic Instruction Code Kit'

$VersionInfo:FILEVERSION#=1,1,0,2024
$VersionInfo:PRODUCTVERSION#=1,1,0,2024

Dim Shared StartDir As String

